//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Doctor, DoctorDocument } from '../Doctor';
import { DoctorService } from '../DoctorService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Doctor')
@UseBefore(checkApiDisabled(DoctorBaseController))
export class DoctorBaseController extends BaseController {
    protected model: Model<DoctorDocument>;

    protected static readonly _objName: string = 'Doctor';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ,
        create: MEDICALPRACTICE_PERMISSIONS.DOCTOR.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.DOCTOR.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.DOCTOR.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(doctorService: DoctorService) {
        super(Doctor, doctorService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(DoctorBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async getAllDoctor(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(DoctorBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async getOneDoctor(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(DoctorBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async postDoctor(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(DoctorBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async patchDoctor(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(DoctorBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async deleteDoctor(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsDoctor(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(DoctorBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async getCsvExportDoctor(@Res() response, @QueryParams() query) {
        response.attachment(`${DoctorBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(DoctorBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async getXlsxExportDoctor(@Res() response, @QueryParams() query) {
        response.attachment(`${DoctorBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(DoctorBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.DOCTOR.READ))
    @UseBefore(authenticated)
    public async getPdfExportDoctor(@Res() response, @QueryParams() query) {
        response.attachment(`${DoctorBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
